﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using System.Threading;

namespace TasksParentRelationship {
	class Program {
		static void Main(string[] args) {

			Console.WriteLine("Main (in thread {0}): creating task 1 ...", Thread.CurrentThread.ManagedThreadId);

			var t1 = Task.Factory.StartNew(() => {
				Console.WriteLine("Task 1 (in thread {0}): started and creating task 2 ...", Thread.CurrentThread.ManagedThreadId);

				var t2 = Task.Factory.StartNew(() => {
					Console.WriteLine("Task 2 (in thread {0}): started and sleeping ...", Thread.CurrentThread.ManagedThreadId);

					Thread.Sleep(500);

					Console.WriteLine("Task 2 (in thread {0}): done sleeping ...", Thread.CurrentThread.ManagedThreadId);
				});

				Console.WriteLine("Task 1 (in thread {0}): done ...", Thread.CurrentThread.ManagedThreadId);
			});

			Console.WriteLine("Main: waiting for task 1 ...");
			t1.Wait();
			Console.WriteLine("Main: successfully finished waiting for task 1 ...");

			Console.WriteLine("Main: sleeping ...");
			Thread.Sleep(1000);
			Console.WriteLine("Main: done sleeping ...");
			Console.WriteLine("------------");
			Console.Write("Press ENTER to repeat test ...");
			Console.ReadLine();

			//
			//
			//

			Console.WriteLine("Main (in thread {0}): creating task 3 ...", Thread.CurrentThread.ManagedThreadId);

			var t3 = Task.Factory.StartNew(() => {
				Console.WriteLine("Task 3 (in thread {0}): started and creating task 4 ...", Thread.CurrentThread.ManagedThreadId);

				var t4 = Task.Factory.StartNew(() => {
					Console.WriteLine("Task 4 (in thread {0}): started and sleeping ...", Thread.CurrentThread.ManagedThreadId);

					Thread.Sleep(500);

					Console.WriteLine("Task 4 (in thread {0}): done sleeping ...", Thread.CurrentThread.ManagedThreadId);
				}, TaskCreationOptions.AttachedToParent);

				Console.WriteLine("Task 3 (in thread {0}): done ...", Thread.CurrentThread.ManagedThreadId);
			});

			Console.WriteLine("Main: waiting for task 3 ...");
			t3.Wait();
			Console.WriteLine("Main: successfully finished waiting for task 3 ...");

			Console.WriteLine("Main: sleeping ...");
			Thread.Sleep(1000);
			Console.WriteLine("Main: done sleeping ...");
			Console.WriteLine("------------");
			Console.Write("Press ENTER to repeat test ...");
			Console.ReadLine();

			//
			//
			//

			Console.WriteLine("Main (in thread {0}): creating task 5 ...", Thread.CurrentThread.ManagedThreadId);

			var t5 = Task.Factory.StartNew(() => {
				Console.WriteLine("Task 5 (in thread {0}): started and creating task 6 ...", Thread.CurrentThread.ManagedThreadId);

				var t6 = Task.Factory.StartNew(() => {
					Console.WriteLine("Task 6 (in thread {0}): started and sleeping ...", Thread.CurrentThread.ManagedThreadId);

					Thread.Sleep(500);

					Console.WriteLine("Task 6 (in thread {0}): done sleeping ...", Thread.CurrentThread.ManagedThreadId);
				}, TaskCreationOptions.AttachedToParent);

				Console.WriteLine("Task 5 (in thread {0}): done ...", Thread.CurrentThread.ManagedThreadId);
			}, TaskCreationOptions.DenyChildAttach);

			Console.WriteLine("Main: waiting for task 5 ...");
			t5.Wait();
			Console.WriteLine("Main: successfully finished waiting for task 5 ...");

			Console.WriteLine("Main: sleeping ...");
			Thread.Sleep(1000);
			Console.WriteLine("Main: done sleeping ...");

			Console.WriteLine("Main: done ...");
		}
	}
}
